﻿Imports System.Text.RegularExpressions


Public Class frmMain

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LoadSettings()
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Private Sub btnRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRun.Click
        'Ok so this is wher it is going to run somthing
        'but what will that do?????
        '-Save current settings
        '-Check Form Input
        '-Check If target dir is empty or needs to be created
        '-execute command to hg as needed, read input and prepare list of paths
        '-copy files from current to target dir
        '

        SaveSettings()

        If ValidateForm("main") = False Then Exit Sub

        If ExecuteHgCommand() = False Then Exit Sub

        CopyFileToTarget()

    End Sub

    Private Sub BtnList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnList.Click
        SaveSettings()

        If ValidateForm("not main, no check for file count") = False Then Exit Sub

        If ExecuteHgCommand() = False Then Exit Sub
    End Sub

    Private Sub btnBrowseMainPath_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowseMainPath.Click

        fbd.SelectedPath = tbMainPath.Text
        fbd.ShowDialog(Me)
        tbMainPath.Text = fbd.SelectedPath

    End Sub

    Private Sub btnBrowseTargetPath_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowseTargetPath.Click
        fbd.SelectedPath = tbTargetPath.Text
        fbd.ShowDialog(Me)
        tbTargetPath.Text = fbd.SelectedPath
    End Sub



#Region "Inner Functions"

    Private Sub SaveSettings()

        My.Settings.MainPath = tbMainPath.Text
        My.Settings.TargetPath = tbTargetPath.Text
        My.Settings.fromRev = tbFromRev.Text

        My.Settings.Save()

    End Sub

    Private Sub LoadSettings()

        tbMainPath.Text = My.Settings.MainPath
        tbTargetPath.Text = My.Settings.TargetPath
        tbFromRev.Text = My.Settings.fromRev

    End Sub

    Private Function ValidateForm(ByVal mtype As String) As Boolean

        'is target valid path and empty?
        If IO.Directory.Exists(tbTargetPath.Text) = False Then
            MsgBox("Target directory does not exist, please check and retry", MsgBoxStyle.Exclamation, "invalid target dir")
            Return False
            Exit Function
        End If

        If IO.Directory.EnumerateFiles(tbTargetPath.Text).Count > 0 And mtype = "main" Then
            MsgBox("Target directory is not empty, please delete existing files or create a new directory", MsgBoxStyle.Exclamation, "target dir not empty")
            Return False
            Exit Function
        End If

        'is main valid path
        If IO.Directory.Exists(tbMainPath.Text) = False Then
            MsgBox("Main repository directory does not exist, please check and retry", MsgBoxStyle.Exclamation, "invalid main dir")
            Return False
            Exit Function
        End If

        'does .hg exist.
        If IO.Directory.Exists(tbMainPath.Text & "\.hg") = False Then
            MsgBox("Main directory is not the root directory of a mercurial repository.", MsgBoxStyle.Exclamation, "invalid main dir not hg")
            Return False
            Exit Function
        End If

        'check from rev
        If tbFromRev.Text = "" Then
            MsgBox("Please enter a revision number to check for changes from", MsgBoxStyle.Exclamation, "no rev from number")
            Return False
            Exit Function
        End If

        Return True

    End Function

    Private Function ExecuteHgCommand() As Boolean

        
        'execute command and read result and check for error.

        If IO.File.Exists(System.IO.Path.GetTempPath() & "mercoutput.txt") Then
            IO.File.Delete(System.IO.Path.GetTempPath() & "mercoutput.txt")
        End If

        Dim process As New Process

        process.StartInfo.FileName = "hg"
        process.StartInfo.Arguments = "diff -r" & Trim(tbFromRev.Text) & ":tip --stat"
        process.StartInfo.WorkingDirectory = tbMainPath.Text
        process.StartInfo.UseShellExecute = False
        process.StartInfo.ErrorDialog = False
        process.StartInfo.RedirectStandardOutput = True
        process.StartInfo.CreateNoWindow = True
        process.Start()

        Dim oWrite As System.IO.StreamWriter
        oWrite = IO.File.CreateText(System.IO.Path.GetTempPath() & "mercoutput.txt")
        oWrite.Write(process.StandardOutput.ReadToEnd)

        process.WaitForExit()
        oWrite.Close()

        'now process and get folder paths.
        'clear pathList just in case.
        lstFiles.Items.Clear()

        If IO.File.Exists(System.IO.Path.GetTempPath() & "mercoutput.txt") Then
            Dim tmpStr = ""
            Dim tmpFileNameMaybe = ""

            Dim objReader As New System.IO.StreamReader(System.IO.Path.GetTempPath() & "mercoutput.txt")
            While objReader.Peek <> -1

                tmpStr = Mid(objReader.ReadLine(), 2)

                tmpFileNameMaybe = Mid(tmpStr, 1, InStr(tmpStr, "|"))

                tmpFileNameMaybe = Trim(tmpFileNameMaybe.Replace("|", ""))

                If InStr(tmpFileNameMaybe, ".") > 0 Then
                    lstFiles.Items.Add(tmpFileNameMaybe.Replace("/", "\"))

                End If
            End While

            objReader.Close()
        Else
            MsgBox("temp file not created")
            Return False
        End If

        If lstFiles.Items.Count = 0 Then
            MsgBox("No changes found")
            Return False

        End If




        Return True

    End Function

    Private Sub CopyFileToTarget()
        Dim i = 0
        Dim destDir = ""
        Dim slashPosition As Integer

        For x = i To lstFiles.Items.Count - 1
            'get dir and create path.
            destDir = tbTargetPath.Text & "\" & lstFiles.Items(x).ToString
            
            slashPosition = destDir.LastIndexOf("\")

            Dim destDirOnly As String = Mid(destDir, 1, slashPosition)
            If IO.Directory.Exists(destDirOnly) = False Then
                IO.Directory.CreateDirectory(destDirOnly)
            End If

            If IO.File.Exists(tbMainPath.Text & "\" & lstFiles.Items(x).ToString) Then
                IO.File.Copy(tbMainPath.Text & "\" & lstFiles.Items(x).ToString, tbTargetPath.Text & "\" & lstFiles.Items(x).ToString, True)
            Else
                MsgBox("File " & tbMainPath.Text & "\" & lstFiles.Items(x).ToString & " has been skipped as it no longer exists in the Main path, this may be a removed or renamed file.", MsgBoxStyle.Information, "File not found")
            End If
            
        Next

        MsgBox("Files copied and exported to target directory")

    End Sub

#End Region

End Class
